import java.util.Stack;

/**
 * Ett program som demonstrerar anvndandet av en stack.
 * @author fki@kth.se
 *
 */
public class StackDemo {
	
	/**
	 * Skriver ut stacken 'rttvnd', dvs det versta elementet frst
	 * @param s Stacken att skriva ut
	 */
	private void showStack (Stack s) {
		if (!s.isEmpty()) {
			Object o = s.pop(); // Take off top element
			System.out.println(o); // Print it
			showStack(s);  // recursion
			s.push(o); // Put top element back
		}
	}
	
	/**
	 * Skriver ut stacken med det understa elementet frst
	 * @param s Stacken att skriva ut
	 */
	private void showStackX (Stack s) {
		for(Object o : s) {
			System.out.println(o);
		}
	}

	public void doStackDemo() {
		Stack<String> myStack = new Stack<String>();
		
		myStack.push("first (at bottom)");
		myStack.push("second (in middle)");
		myStack.push("third (on top)");
		
		showStack(myStack);
		
		System.out.println();
		
		myStack.pop();
		
		showStack(myStack);
				
		System.out.println();
		
		Stack<Integer> intStack = new Stack<Integer>();
		
		intStack.push(0);
		intStack.push(500);
		intStack.push(1000);
		intStack.push(2000);
		
		showStack(intStack);
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new StackDemo().doStackDemo();

	}

}
